#!/usr/bin/env bash
set -e
set -u
set -o pipefail

operation="${1}"; shift

case "${operation}" in
    "deploy_challenge")
        while [ "$#" != 0 ]; do
            domain="${1}"; shift
            token_id="${1}"; shift
            token="${1}"; shift
            statuscode="$(curl -s -k -n -L -o /dev/null -w "%{http_code}" "https://${domain}/.well-known/acme-challenge/manage_addFile?id=${token_id}")"
            if [[ ! "${statuscode:0:1}" = "2" ]]; then
                statuscode="$(curl -s -n -L -o /dev/null -w "%{http_code}" "http://${domain}/.well-known/acme-challenge/manage_addFile?id=${token_id}")"
                if [[ ! "${statuscode:0:1}" = "2" ]]; then
                    echo 'Failed'
                    exit 1
                fi
            fi
            statuscode="$(curl -s -k -n -L -o /dev/null -w "%{http_code}" "https://${domain}/.well-known/acme-challenge/${token_id}/manage_edit?title=&content_type=text/plain&filedata=${token}")"
            if [[ ! "${statuscode:0:1}" = "2" ]]; then
                statuscode="$(curl -s -n -L -o /dev/null -w "%{http_code}" "http://${domain}/.well-known/acme-challenge/${token_id}/manage_edit?title=&content_type=text/plain&filedata=${token}")"
                if [[ ! "${statuscode:0:1}" = "2" ]]; then
                    echo 'Failed'
                    exit 1
                fi
            fi
        done
    ;;
    "clean_challenge")
        while [ "$#" != 0 ]; do
            domain="${1}"; shift
            token_id="${1}"; shift
            token="${1}"; shift
            statuscode="$(curl -s -k -n -L -o /dev/null -w "%{http_code}" "https://${domain}/.well-known/acme-challenge/manage_delObjects?ids:list=${token_id}")"
            if [[ ! "${statuscode:0:1}" = "2" ]]; then
                statuscode="$(curl -s -n -L -o /dev/null -w "%{http_code}" "http://${domain}/.well-known/acme-challenge/manage_delObjects?ids:list=${token_id}")"
                if [[ ! "${statuscode:0:1}" = "2" ]]; then
                    echo 'Failed'
                    exit 1
                fi
            fi
        done
    ;;
esac

exit 0
